/****************************************************************************
Copyright (c) [2012 - 2017] Texas Instruments Incorporated

All rights reserved not granted herein.

Limited License.

 Texas Instruments Incorporated grants a world-wide, royalty-free, non-exclusive
 license under copyrights and patents it now or hereafter owns or controls to
 make,  have made, use, import, offer to sell and sell ('Utilize') this software
 subject to the terms herein.  With respect to the foregoing patent license,
 such license is granted  solely to the extent that any such patent is necessary
 to Utilize the software alone.  The patent license shall not apply to any
 combinations which include this software, other than combinations with devices
 manufactured by or for TI ('TI Devices').  No hardware patent is licensed
 hereunder.

 Redistributions must preserve existing copyright notices and reproduce this
 license (including the above copyright notice and the disclaimer and
 (if applicable) source code license limitations below) in the documentation
 and/or other materials provided with the distribution

 Redistribution and use in binary form, without modification, are permitted
 provided that the following conditions are met:

 * No reverse engineering, decompilation, or disassembly of this software
   is permitted with respect to any software provided in binary form.

 * Any redistribution and use are licensed by TI for use only with TI Devices.

 * Nothing shall obligate TI to provide you with source code for the software
   licensed and provided to you in object code.

 If software source code is provided to you, modification and redistribution of
 the source code are permitted provided that the following conditions are met:

 * Any redistribution and use of the source code, including any resulting
   derivative works, are licensed by TI for use only with TI Devices.

 * Any redistribution and use of any object code compiled from the source code
   and any resulting derivative works, are licensed by TI for use only with TI
   Devices.

 Neither the name of Texas Instruments Incorporated nor the names of its
 suppliers may be used to endorse or promote products derived from this software
 without specific prior written permission.

 DISCLAIMER.

 THIS SOFTWARE IS PROVIDED BY TI AND TIS LICENSORS 'AS IS' AND ANY EXPRESS OR
 IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 IN NO EVENT SHALL TI AND TIS LICENSORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
 OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
 ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
******************************************************************************
*/
/*
*******************************************************************************
*
* IMPORTANT NOTE:
*  This file is AUTO-GENERATED by Vision SDK use case generation tool
*
*******************************************************************************
*/
#include "radar_boardCaptureOnly_priv.h"
Void radar_boardCaptureOnly_SetLinkId(radar_boardCaptureOnlyObj *pObj){
       pObj->IssCaptureLinkID               = SYSTEM_LINK_ID_ISSCAPTURE_0;
       pObj->IPCOut_IPU1_0_IPU1_1_0LinkID   = IPU1_0_LINK (SYSTEM_LINK_ID_IPC_OUT_0);
       pObj->IPCIn_IPU1_1_IPU1_0_0LinkID    = IPU1_1_LINK (SYSTEM_LINK_ID_IPC_IN_0);
       pObj->NetworkTxLinkID                = IPU1_1_LINK (SYSTEM_LINK_ID_NETWORK_TX_0);
}

Void radar_boardCaptureOnly_ResetLinkPrms(radar_boardCaptureOnlyObj *pObj){
       IssCaptureLink_CreateParams_Init(&pObj->IssCapturePrm);
       IpcLink_CreateParams_Init(&pObj->IPCOut_IPU1_0_IPU1_1_0Prm);
       IpcLink_CreateParams_Init(&pObj->IPCIn_IPU1_1_IPU1_0_0Prm);
       NetworkTxLink_CreateParams_Init (&pObj->NetworkTxPrm);
}

Void radar_boardCaptureOnly_SetPrms(radar_boardCaptureOnlyObj *pObj){
       (pObj->NetworkTxPrm).numInQue = 1;
}

Void radar_boardCaptureOnly_ConnectLinks(radar_boardCaptureOnlyObj *pObj){

       //IssCapture -> IPCOut_IPU1_0_IPU1_1_0
       pObj->IssCapturePrm.outQueParams.nextLink = pObj->IPCOut_IPU1_0_IPU1_1_0LinkID;
       pObj->IPCOut_IPU1_0_IPU1_1_0Prm.inQueParams.prevLinkId = pObj->IssCaptureLinkID;
       pObj->IPCOut_IPU1_0_IPU1_1_0Prm.inQueParams.prevLinkQueId = 0;

       //IPCOut_IPU1_0_IPU1_1_0 -> IPCIn_IPU1_1_IPU1_0_0
       pObj->IPCOut_IPU1_0_IPU1_1_0Prm.outQueParams.nextLink = pObj->IPCIn_IPU1_1_IPU1_0_0LinkID;
       pObj->IPCIn_IPU1_1_IPU1_0_0Prm.inQueParams.prevLinkId = pObj->IPCOut_IPU1_0_IPU1_1_0LinkID;
       pObj->IPCIn_IPU1_1_IPU1_0_0Prm.inQueParams.prevLinkQueId = 0;

       //IPCIn_IPU1_1_IPU1_0_0 -> NetworkTx
       pObj->IPCIn_IPU1_1_IPU1_0_0Prm.outQueParams.nextLink = pObj->NetworkTxLinkID;
       pObj->NetworkTxPrm.inQueParams[0].prevLinkId = pObj->IPCIn_IPU1_1_IPU1_0_0LinkID;
       pObj->NetworkTxPrm.inQueParams[0].prevLinkQueId = 0;

}

Int32 radar_boardCaptureOnly_Create(radar_boardCaptureOnlyObj *pObj, Void *appObj){

       Int32 status;

       radar_boardCaptureOnly_SetLinkId(pObj);
       radar_boardCaptureOnly_ResetLinkPrms(pObj);

       radar_boardCaptureOnly_SetPrms(pObj);
       radar_boardCaptureOnly_SetAppPrms(pObj, appObj);

       radar_boardCaptureOnly_ConnectLinks(pObj);
       status = System_linkCreate(pObj->IssCaptureLinkID, &pObj->IssCapturePrm, sizeof(pObj->IssCapturePrm));
       UTILS_assert(status == SYSTEM_LINK_STATUS_SOK);

       status = System_linkCreate(pObj->IPCOut_IPU1_0_IPU1_1_0LinkID, &pObj->IPCOut_IPU1_0_IPU1_1_0Prm, sizeof(pObj->IPCOut_IPU1_0_IPU1_1_0Prm));
       UTILS_assert(status == SYSTEM_LINK_STATUS_SOK);

       status = System_linkCreate(pObj->IPCIn_IPU1_1_IPU1_0_0LinkID, &pObj->IPCIn_IPU1_1_IPU1_0_0Prm, sizeof(pObj->IPCIn_IPU1_1_IPU1_0_0Prm));
       UTILS_assert(status == SYSTEM_LINK_STATUS_SOK);

       status = System_linkCreate(pObj->NetworkTxLinkID, &pObj->NetworkTxPrm, sizeof(pObj->NetworkTxPrm));
       UTILS_assert(status == SYSTEM_LINK_STATUS_SOK);

       return status;
}

Int32 radar_boardCaptureOnly_Start(radar_boardCaptureOnlyObj *pObj){

       Int32 status;

       status = System_linkStart(pObj->NetworkTxLinkID);
       UTILS_assert(status == SYSTEM_LINK_STATUS_SOK);

       status = System_linkStart(pObj->IPCIn_IPU1_1_IPU1_0_0LinkID);
       UTILS_assert(status == SYSTEM_LINK_STATUS_SOK);

       status = System_linkStart(pObj->IPCOut_IPU1_0_IPU1_1_0LinkID);
       UTILS_assert(status == SYSTEM_LINK_STATUS_SOK);

       status = System_linkStart(pObj->IssCaptureLinkID);
       UTILS_assert(status == SYSTEM_LINK_STATUS_SOK);

       return status;
}

Int32 radar_boardCaptureOnly_Stop(radar_boardCaptureOnlyObj *pObj){

       Int32 status;

       status = System_linkStop(pObj->NetworkTxLinkID);
       UTILS_assert(status == SYSTEM_LINK_STATUS_SOK);

       status = System_linkStop(pObj->IPCIn_IPU1_1_IPU1_0_0LinkID);
       UTILS_assert(status == SYSTEM_LINK_STATUS_SOK);

       status = System_linkStop(pObj->IPCOut_IPU1_0_IPU1_1_0LinkID);
       UTILS_assert(status == SYSTEM_LINK_STATUS_SOK);

       status = System_linkStop(pObj->IssCaptureLinkID);
       UTILS_assert(status == SYSTEM_LINK_STATUS_SOK);

       return status;
}

Int32 radar_boardCaptureOnly_Delete(radar_boardCaptureOnlyObj *pObj){

       Int32 status;

       status = System_linkDelete(pObj->NetworkTxLinkID);
       UTILS_assert(status == SYSTEM_LINK_STATUS_SOK);

       status = System_linkDelete(pObj->IPCIn_IPU1_1_IPU1_0_0LinkID);
       UTILS_assert(status == SYSTEM_LINK_STATUS_SOK);

       status = System_linkDelete(pObj->IPCOut_IPU1_0_IPU1_1_0LinkID);
       UTILS_assert(status == SYSTEM_LINK_STATUS_SOK);

       status = System_linkDelete(pObj->IssCaptureLinkID);
       UTILS_assert(status == SYSTEM_LINK_STATUS_SOK);

       return status;
}

Void radar_boardCaptureOnly_printBufferStatistics(radar_boardCaptureOnlyObj *pObj){
       System_linkPrintBufferStatistics(pObj->IssCaptureLinkID);
       System_linkPrintBufferStatistics(pObj->IPCOut_IPU1_0_IPU1_1_0LinkID);
       Task_sleep(500);
       System_linkPrintBufferStatistics(pObj->IPCIn_IPU1_1_IPU1_0_0LinkID);
       System_linkPrintBufferStatistics(pObj->NetworkTxLinkID);
       Task_sleep(500);
}

Void radar_boardCaptureOnly_printStatistics(radar_boardCaptureOnlyObj *pObj){
       System_linkPrintStatistics(pObj->IssCaptureLinkID);
       System_linkPrintStatistics(pObj->IPCOut_IPU1_0_IPU1_1_0LinkID);
       Task_sleep(500);
       System_linkPrintStatistics(pObj->IPCIn_IPU1_1_IPU1_0_0LinkID);
       System_linkPrintStatistics(pObj->NetworkTxLinkID);
       Task_sleep(500);
}

